当前位置:   article > 正文

刷题——leetcode——top100——121-160_(worddict.contains(s.substring(start, end)) && wor

(worddict.contains(s.substring(start, end)) && word_break(s, worddict, end,

136. 只出现一次的数字

给定一个非空整数数组,除了某个元素只出现一次以外,其余每个元素均出现两次。找出那个只出现了一次的元素。

说明:

你的算法应该具有线性时间复杂度。 你可以不使用额外空间来实现吗?

示例 1:

输入: [2,2,1]
输出: 1
示例 2:

输入: [4,1,2,1,2]
输出: 4

  1. class Solution {
  2. public int singleNumber(int[] nums) {
  3. int result = 0;
  4. for (int i = 0; i < nums.length; i++) {
  5. result = result ^ nums[i];
  6. }
  7. return result;
  8. }
  9. }

139. 单词拆分

给定一个非空字符串 s 和一个包含非空单词列表的字典 wordDict,判定 s 是否可以被空格拆分为一个或多个在字典中出现的单词。

说明:

拆分时可以重复使用字典中的单词。
你可以假设字典中没有重复的单词。
示例 1:

输入: s = "leetcode", wordDict = ["leet", "code"]
输出: true
解释: 返回 true 因为 "leetcode" 可以被拆分成 "leet code"。
示例 2:

输入: s = "applepenapple", wordDict = ["apple", "pen"]
输出: true
解释: 返回 true 因为 "applepenapple" 可以被拆分成 "apple pen apple"。
     注意你可以重复使用字典中的单词。
示例 3:

输入: s = "catsandog", wordDict = ["cats", "dog", "sand", "and", "cat"]
输出: false

方法 1:暴力
算法

最简单的实现方法是用递归和回溯。为了找到解,我们可以检查字典单词中每一个单词的可能前缀,如果在字典中出现过,那么去掉这个前缀后剩余部分回归调用。同时,如果某次函数调用中发现整个字符串都已经被拆分且在字典中出现过了,函数就返回 true 。

  1. public class Solution {
  2.     public boolean wordBreak(String s, List<String> wordDict) {
  3.         return word_Break(s, new HashSet(wordDict), 0);
  4.     }
  5.     public boolean word_Break(String s, Set<String> wordDict, int start) {
  6.         if (start == s.length()) {
  7.             return true;
  8.         }
  9.         for (int end = start + 1; end <= s.length(); end++) {
  10.             if (wordDict.contains(s.substring(start, end)) && word_Break(s, wordDict, end)){
  11.                 return true;
  12.             }
  13.         }
  14.         return false;
  15.     }
  16. }


复杂度分析

时间复杂度:O(n^n)。考虑最坏情况 ss = aaaaaaa 。每一个前缀都在字典中,此时回溯树的复杂度会达到 n^n。
空间复杂度:O(n)O(n) 。回溯树的深度最深达到 n。


方法 2:记忆化回溯
算法

在先前的方法中,我们看到许多函数调用都是冗余的,也就是我们会对相同的字符串调用多次回溯函数。为了避免这种情况,我们可以使用记忆化的方法,其中一个 memomemo 数组会被用来保存子问题的结果。每当访问到已经访问过的后缀串,直接用 memomemo 数组中的值返回而不需要继续调用函数。

通过记忆化,许多冗余的子问题可以极大被优化,回溯树得到了剪枝,因此极大减小了时间复杂度。

  1. public class Solution {
  2.     public boolean wordBreak(String s, List<String> wordDict) {
  3.         return word_Break(s, new HashSet(wordDict), 0, new Boolean[s.length()]);
  4.     }
  5.     public boolean word_Break(String s, Set<String> wordDict, int start, Boolean[] memo) {
  6.         if (start == s.length()) {
  7.             return true;
  8.         }
  9.         if (memo[start] != null) {
  10.             return memo[start];
  11.         }
  12.         for (int end = start + 1; end <= s.length(); end++) {
  13.             if (wordDict.contains(s.substring(start, end)) && word_Break(s, wordDict, end, memo)) {
  14.                 return memo[start] = true;
  15.             }
  16.         }
  17.         return memo[start] = false;
  18.     }
  19. }

复杂度分析

时间复杂度:O(n^2)。回溯树的大小最多达到 n^2 。

空间复杂度:O(n) 。回溯树的深度可以达到 n 级别。

方法 3:使用宽度优先搜索

另一个方法是使用宽度优先搜索。将字符串可视化成一棵树,每一个节点是用 endend 为结尾的前缀字符串。当两个节点之间的所有节点都对应了字典中一个有效字符串时,两个节点可以被连接。

为了形成这样的一棵树,我们从给定字符串的第一个字符开始(比方说 ss ),将它作为树的根部,开始找所有可行的以该字符为首字符的可行子串。进一步的,将每一个子字符串的结束字符的下标(比方说 ii)放在队列的尾部供宽搜后续使用。

每次我们从队列最前面弹出一个元素,并考虑字符串 s(i+1,end)s(i+1,end) 作为原始字符串,并将当前节点作为树的根。这个过程会一直重复,直到队列中没有元素。如果字符串最后的元素可以作为树的一个节点,这意味着初始字符串可以被拆分成多个给定字典中的子字符串。

  1. public class Solution {
  2.     public boolean wordBreak(String s, List<String> wordDict) {
  3.         Set<String> wordDictSet=new HashSet(wordDict);
  4.         Queue<Integer> queue = new LinkedList<>();
  5.         int[] visited = new int[s.length()];
  6.         queue.add(0);
  7.         while (!queue.isEmpty()) {
  8.             int start = queue.remove();
  9.             if (visited[start] == 0) {
  10.                 for (int end = start + 1; end <= s.length(); end++) {
  11.                     if (wordDictSet.contains(s.substring(start, end))) {
  12.                         queue.add(end);
  13.                         if (end == s.length()) {
  14.                             return true;
  15.                         }
  16.                     }
  17.                 }
  18.                 visited[start] = 1;
  19.             }
  20.         }
  21.         return false;
  22.     }
  23. }

复杂度分析

时间复杂度:O(n^2)。对于每个开始的位置,搜索会直到给定字符串的尾部结束。

空间复杂度:O(n) 。队列的大小最多 n。

方法 4:使用动态规划

这个方法的想法是对于给定的字符串(ss)可以被拆分成子问题 s1s1 和 s2s2 。如果这些子问题都可以独立地被拆分成符合要求的子问题,那么整个问题 ss 也可以满足。也就是,如果 "catsanddog" 可以拆分成两个子字符串 "catsand" 和 "dog" 。子问题 "catsand" 可以进一步拆分成 "cats" 和 "and" ,这两个独立的部分都是字典的一部分,所以 "catsand" 满足题意条件,再往前, "catsand" 和 "dog" 也分别满足条件,所以整个字符串 "catsanddog" 也满足条件。

现在,我们考虑 dp 数组求解的过程。我们使用 n+1大小数组的 dp ,其中 n是给定字符串的长度。我们也使用 2 个下标指针 i 和 j,其中 i是当前字符串从头开始的子字符串(s')的长度, j是当前子字符串(s')的拆分位置,拆分成 s'(0,j)和 s'(j+1,i)。

为了求出 dp 数组,我们初始化 dp[0] 为 true ,这是因为空字符串总是字典的一部分。dp 数组剩余的元素都初始化为false 。

我们用下标i 来考虑所有从当前字符串开始的可能的子字符串。对于每一个子字符串,我们通过下标 jj 将它拆分成 s1′和 s2'(注意 i现在指向 s2' 的结尾)。为了将 dp[i] 数组求出来,我们依次检查每个 dp[j] 是否为 true ,也就是子字符串 s1'是否满足题目要求。如果满足,我们接下来检查 s2'是否在字典中。如果包含,我们接下来检查 s2'是否在字典中,如果两个字符串都满足要求,我们让dp[i] 为 true ,否则令其为 false 。

  1. public class Solution {
  2.     public boolean wordBreak(String s, List<String> wordDict) {
  3.         Set<String> wordDictSet=new HashSet(wordDict);
  4.         boolean[] dp = new boolean[s.length() + 1];
  5.         dp[0] = true;
  6.         for (int i = 1; i <= s.length(); i++) {
  7.             for (int j = 0; j < i; j++) {
  8.                 if (dp[j] && wordDictSet.contains(s.substring(j, i))) {
  9.                     dp[i] = true;
  10.                     break;
  11.                 }
  12.             }
  13.         }
  14.         return dp[s.length()];
  15.     }
  16. }

复杂度分析

时间复杂度:O(n^2)。求出dp 数组需要两重循环。

空间复杂度:O(n)。 dpdp 数组的长度是 n+1 。

141. 环形链表

给定一个链表,判断链表中是否有环。

为了表示给定链表中的环,我们使用整数 pos 来表示链表尾连接到链表中的位置(索引从 0 开始)。 如果 pos 是 -1,则在该链表中没有环。

 

示例 1:

输入:head = [3,2,0,-4], pos = 1
输出:true
解释:链表中有一个环,其尾部连接到第二个节点。


示例 2:

输入:head = [1,2], pos = 0
输出:true
解释:链表中有一个环,其尾部连接到第一个节点。


示例 3:

输入:head = [1], pos = -1
输出:false
解释:链表中没有环。


 

进阶:

你能用 O(1)(即,常量)内存解决此问题吗?

摘要
本文适用于初学者。它涉及了以下几个概念:链表,哈希表和双指针。

解决方案
方法一:哈希表
思路

我们可以通过检查一个结点此前是否被访问过来判断链表是否为环形链表。常用的方法是使用哈希表。

算法

我们遍历所有结点并在哈希表中存储每个结点的引用(或内存地址)。如果当前结点为空结点 null(即已检测到链表尾部的下一个结点),那么我们已经遍历完整个链表,并且该链表不是环形链表。如果当前结点的引用已经存在于哈希表中,那么返回 true(即该链表为环形链表)。

  1. public boolean hasCycle(ListNode head) {
  2.     Set<ListNode> nodesSeen = new HashSet<>();
  3.     while (head != null) {
  4.         if (nodesSeen.contains(head)) {
  5.             return true;
  6.         } else {
  7.             nodesSeen.add(head);
  8.         }
  9.         head = head.next;
  10.     }
  11.     return false;
  12. }

复杂度分析

时间复杂度:O(n),对于含有 n 个元素的链表,我们访问每个元素最多一次。添加一个结点到哈希表中只需要花费 O(1)的时间。

空间复杂度:O(n),空间取决于添加到哈希表中的元素数目,最多可以添加 n 个元素。

方法二:双指针
思路

想象一下,两名运动员以不同的速度在环形赛道上跑步会发生什么?

算法

通过使用具有 不同速度 的快、慢两个指针遍历链表,空间复杂度可以被降低至 O(1)O(1)。慢指针每次移动一步,而快指针每次移动两步。

如果列表中不存在环,最终快指针将会最先到达尾部,此时我们可以返回 false。

现在考虑一个环形链表,把慢指针和快指针想象成两个在环形赛道上跑步的运动员(分别称之为慢跑者与快跑者)。而快跑者最终一定会追上慢跑者。这是为什么呢?考虑下面这种情况(记作情况 A)- 假如快跑者只落后慢跑者一步,在下一次迭代中,它们就会分别跑了一步或两步并相遇。

其他情况又会怎样呢?例如,我们没有考虑快跑者在慢跑者之后两步或三步的情况。但其实不难想到,因为在下一次或者下下次迭代后,又会变成上面提到的情况 A。

  1. public boolean hasCycle(ListNode head) {
  2.     if (head == null || head.next == null) {
  3.         return false;
  4.     }
  5.     ListNode slow = head;
  6.     ListNode fast = head.next;
  7.     while (slow != fast) {
  8.         if (fast == null || fast.next == null) {
  9.             return false;
  10.         }
  11.         slow = slow.next;
  12.         fast = fast.next.next;
  13.     }
  14.     return true;
  15. }

142. 环形链表 II

给定一个链表,返回链表开始入环的第一个节点。 如果链表无环,则返回 null。

为了表示给定链表中的环,我们使用整数 pos 来表示链表尾连接到链表中的位置(索引从 0 开始)。 如果 pos 是 -1,则在该链表中没有环。

说明:不允许修改给定的链表。

 

示例 1:

输入:head = [3,2,0,-4], pos = 1
输出:tail connects to node index 1
解释:链表中有一个环,其尾部连接到第二个节点。


示例 2:

输入:head = [1,2], pos = 0
输出:tail connects to node index 0
解释:链表中有一个环,其尾部连接到第一个节点。


示例 3:

输入:head = [1], pos = -1
输出:no cycle
解释:链表中没有环。方法 1:哈希表
 

  1. public class Solution {
  2.     public ListNode detectCycle(ListNode head) {
  3.         Set<ListNode> visited = new HashSet<ListNode>();
  4.         ListNode node = head;
  5.         while (node != null) {
  6.             if (visited.contains(node)) {
  7.                 return node;
  8.             }
  9.             visited.add(node);
  10.             node = node.next;
  11.         }
  12.         return null;
  13.     }
  14. }

方法 2:快慢指针

  1. public class Solution {
  2.     private ListNode getIntersect(ListNode head) {
  3.         ListNode tortoise = head;
  4.         ListNode hare = head;
  5.         // A fast pointer will either loop around a cycle and meet the slow
  6.         // pointer or reach the `null` at the end of a non-cyclic list.
  7.         while (hare != null && hare.next != null) {
  8.             tortoise = tortoise.next;
  9.             hare = hare.next.next;
  10.             if (tortoise == hare) {
  11.                 return tortoise;
  12.             }
  13.         }
  14.         return null;
  15. }
  16.     public ListNode detectCycle(ListNode head) {
  17.         if (head == null) {
  18.             return null;
  19.         }
  20.         // If there is a cycle, the fast/slow pointers will intersect at some
  21.         // node. Otherwise, there is no cycle, so we cannot find an e***ance to
  22.         // a cycle.
  23.         ListNode intersect = getIntersect(head);
  24.         if (intersect == null) {
  25.             return null;
  26.         }
  27.         // To find the e***ance to the cycle, we have two pointers traverse at
  28.         // the same speed -- one from the front of the list, and the other from
  29.         // the point of intersection.
  30.         ListNode ptr1 = head;
  31.         ListNode ptr2 = intersect;
  32.         while (ptr1 != ptr2) {
  33.             ptr1 = ptr1.next;
  34.             ptr2 = ptr2.next;
  35.         }
  36.         return ptr1;
  37.     }
  38. }

148. 排序链表

在 O(n log n) 时间复杂度和常数级空间复杂度下,对链表进行排序。

示例 1:

输入: 4->2->1->3
输出: 1->2->3->4
示例 2:

输入: -1->5->3->4->0
输出: -1->0->3->4->5

  1. /**
  2. * Definition for singly-linked list.
  3. * public class ListNode {
  4. * int val;
  5. * ListNode next;
  6. * ListNode(int x) { val = x; }
  7. * }
  8. */
  9. class Solution {
  10. public ListNode sortList(ListNode head) {
  11. if(head == null || head.next == null)
  12. return head;
  13. //找到链表的中间节点,一快一慢两个指针
  14. ListNode fast = head;
  15. ListNode slow = head;
  16. ListNode pre = null; //记录第一部分的最后一个节点
  17. //将单链表划分为两部分
  18. while(fast != null && fast.next != null){
  19. fast = fast.next.next;
  20. pre = slow;
  21. slow = slow.next;
  22. }
  23. //将两部分分割开
  24. if(pre != null)
  25. pre.next = null;
  26. //分别对两部分递归排序
  27. ListNode l1 = sortList(head);
  28. ListNode l2 = sortList(slow);
  29. return merge(l1,l2); //归并
  30. }
  31. //归并两个有序序列
  32. public ListNode merge(ListNode l1,ListNode l2){
  33. if(l1 == null)
  34. return l2;
  35. if(l2 == null)
  36. return l1;
  37. ListNode head = new ListNode(-1);
  38. ListNode currNode = head;
  39. while(l1 != null && l2 != null){
  40. if(l1.val < l2.val){
  41. currNode.next = l1; //这里利用单链表的性质,不使用额外的空间,使得空间复杂度为O(1)
  42. l1 = l1.next;
  43. } else {
  44. currNode.next = l2;
  45. l2 = l2.next;
  46. }
  47. currNode = currNode.next;
  48. }
  49. if(l1 != null)
  50. currNode.next = l1;
  51. if(l2 != null)
  52. currNode.next = l2;
  53. return head.next;
  54. }
  55. }

152. 乘积最大子序列

给定一个整数数组 nums ,找出一个序列中乘积最大的连续子序列(该序列至少包含一个数)。

示例 1:

输入: [2,3,-2,4]
输出: 6
解释: 子数组 [2,3] 有最大乘积 6。
示例 2:

输入: [-2,0,-1]
输出: 0
解释: 结果不能为 2, 因为 [-2,-1] 不是子数组。

思路:动态规划
遍历数组时计算当前最大值,不断更新.令imax为当前最大值,则当前最大值为 imax = max(imax * nums[i], nums[i])
由于存在负数,那么会导致最大的变最小的,最小的变最大的。因此还需要维护当前最小值imin,imin = min(imin * nums[i], nums[i]),当负数出现时则imax与imin进行交换再进行下一步计算
时间复杂度:O(n)
代码

  1. class Solution {
  2.     public int maxProduct(int[] nums) {
  3.         int max = Integer.MIN_VALUE, imax = 1, imin = 1;
  4.         for(int i=0; i<nums.length; i++){
  5.             if(nums[i] < 0){ 
  6.               int tmp = imax;
  7.               imax = imin;
  8.               imin = tmp;
  9.             }
  10.             imax = Math.max(imax*nums[i], nums[i]);
  11.             imin = Math.min(imin*nums[i], nums[i]);
  12.             
  13.             max = Math.max(max, imax);
  14.         }
  15.         return max;
  16.     }
  17. }

155. 最小栈

借用一个辅助栈min_stack,用于存储stack中最小值:
push:每当push新值进来时,如果“小于等于”min_stack栈顶值,则一起push到min_stack,即更新了最小值;
pop:判断pop出去的元素值是否是min_stack栈顶元素值(即最小值),如果是则将min_stack栈顶元素一起pop,这样可以保证min_stack栈顶元素始终是stack中的最小值。
getMin:返回min_stack栈顶即可。
min_stack的作用是对stack中的元素做标记,标记的原则是min_stack中元素一定是降序的(栈底最大栈顶最小)。换个角度理解,min_stack等价于遍历stack所有元素,把升序的数字都删除掉,留下一个从栈底到栈顶降序的栈。本题要求获取最小值的复杂度是O(1),因此须构建辅助栈,在push与pop的过程中始终保持辅助栈为一个降序栈。
时间空间复杂度都为O(N),获取最小值复杂度为O(1)。

  1. class MinStack {
  2. private Stack<Integer> stack;
  3. private Stack<Integer> min_stack;
  4. /** initialize your data structure here. */
  5. public MinStack() {
  6. stack = new Stack<>();
  7. min_stack = new Stack<>();
  8. }
  9. public void push(int x) {
  10. stack.push(x);
  11. if(min_stack.isEmpty() || x <= min_stack.peek())
  12. min_stack.push(x);
  13. }
  14. public void pop() {
  15. if(stack.pop().equals(min_stack.peek()))
  16. min_stack.pop();
  17. }
  18. public int top() {
  19. return stack.peek();
  20. }
  21. public int getMin() {
  22. return min_stack.peek();
  23. }
  24. }

160. 相交链表

编写一个程序,找到两个单链表相交的起始节点。

如下面的两个链表:

在节点 c1 开始相交。

 

示例 1:

输入:intersectVal = 8, listA = [4,1,8,4,5], listB = [5,0,1,8,4,5], skipA = 2, skipB = 3
输出:Reference of the node with value = 8
输入解释:相交节点的值为 8 (注意,如果两个列表相交则不能为 0)。从各自的表头开始算起,链表 A 为 [4,1,8,4,5],链表 B 为 [5,0,1,8,4,5]。在 A 中,相交节点前有 2 个节点;在 B 中,相交节点前有 3 个节点。
 

示例 2:

输入:intersectVal = 2, listA = [0,9,1,2,4], listB = [3,2,4], skipA = 3, skipB = 1
输出:Reference of the node with value = 2
输入解释:相交节点的值为 2 (注意,如果两个列表相交则不能为 0)。从各自的表头开始算起,链表 A 为 [0,9,1,2,4],链表 B 为 [3,2,4]。在 A 中,相交节点前有 3 个节点;在 B 中,相交节点前有 1 个节点。
 

示例 3:

输入:intersectVal = 0, listA = [2,6,4], listB = [1,5], skipA = 3, skipB = 2
输出:null
输入解释:从各自的表头开始算起,链表 A 为 [2,6,4],链表 B 为 [1,5]。由于这两个链表不相交,所以 intersectVal 必须为 0,而 skipA 和 skipB 可以是任意值。
解释:这两个链表不相交,因此返回 null。
 

注意:

如果两个链表没有交点,返回 null.
在返回结果后,两个链表仍须保持原有的结构。
可假定整个链表结构中没有循环。
程序尽量满足 O(n) 时间复杂度,且仅用 O(1) 内存。

当你们看到到这里时八成已经看过了评论区里第一位大神的代码了,很多对其代码的解释是消除长度差,事实确实是如此,但是解释有点太过于繁琐,大神消除长度差的方式不是“减去”而是“增加”。 我们寻常消除长度差的思想是,让长的那个链表减去比短的链表多出的那一部分,使两链表长度相同,然后开始遍历,而大神的代码是增加一段距离,使两个新的链表长度相等,然后从起点同时遍历,不管在什么位置,两链表剩余长度都是相同的如图: 

  1. public class Solution {
  2. public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
  3. ListNode ha = headA, hb = headB;
  4. while (ha != hb) {
  5. ha = ha != null ? ha.next : headB;
  6. hb = hb != null ? hb.next : headA;
  7. }
  8. return ha;
  9. }
  10. }

 

声明:本文内容由网友自发贡献,不代表【wpsshop博客】立场,版权归原作者所有,本站不承担相应法律责任。如您发现有侵权的内容,请联系我们。转载请注明出处:https://www.wpsshop.cn/w/小小林熬夜学编程/article/detail/160212
推荐阅读
相关标签
  

闽ICP备14008679号